<template>
	<page>
		<div class="row">
			<div class="col-md-9">
				<crud-form
					v-if="model"
					:form-schema="schema"
					:form-model="model"
					@on-submit="onFormSubmit"
				/>
				<p class="text-danger">
					{{ error }}
				</p>
			</div>
		</div>
	</page>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'

//Схема и модель для реализации полей формы
import { schema, defaultForm } from './fields'

export default {
	name: 'MainForm',
	components: {
		//Компонент для реализации формы
		CrudForm: () => import('@/components/CrudForm'),
		Page: () => import('@/components/Page'),
	},
	computed: {
		...mapGetters({
			item: 'questionnaires/item',
			error: 'questionnaires/itemError'
		}),
		//Модифицируем наш роут, если на формы для изменения находимся
		isUpdating: ({
			$route: {
				params: { id },
			},
		}) => id !== undefined
	},
	data: () => ({
		model: {},
		schema,
		updateModel: {}
	}),
	async mounted() {
		//Проверка на форму для изменения анкеты
		if(this.isUpdating) {
			await this.fetchItem(this.$route.params.id)
			this.updateModel = {
				fullName: 
					this.item.firstName+' '+
					this.item.lastName+' '+
					this.item.middleName
			}
			//заполяет поля у формы для изменения анкеты
			this.model = { ...this.item, ...this.updateModel  }
			return
		}
		this.setModel()
	},
	methods: {
		...mapActions({
			createItem: 'questionnaires/create',
			fetchItem: 'questionnaires/fetchOne',
			updateItem: 'questionnaires/update',
		}),
		setModel () {
			this.model = {
				...defaultForm,
			}
		},
		//Метод изменения анкеты
		async onItemUpdate() {
			const updatedModel = {
				...this.model,
			}
			await this.updateItem({
				id: this.$route.params.id,
				payload: updatedModel,
			})
			this.$router.back()
		},
		//Метод создния анкеты
		async onItemCreate() {
			await this.createItem(this.model)
		},
		//Метод реагирующий от ребенка на отравку формы
		async onFormSubmit() {
			if(this.isUpdating) {
				this.onItemUpdate()
				return
			}
			this.onItemCreate()
		}
	}
}
</script>